%global pypi_name mailman

# The user and group Mailman will run as, same values as in the mailman 2 RPM
%global mmuser       mailman
%global mmuserid     41
%global mmgroup      mailman
%global mmgroupid    41

%if 0%{?fedora}
%{!?python3_pkgversion: %global python3_pkgversion 3}
%else
%{!?python3_pkgversion: %global python3_pkgversion 34}
%endif


Name:           mailman3
Version:        3.1.0
Release:        0.16%{?dist}
Summary:        The GNU mailing list manager

License:        GPLv3
URL:            http://www.list.org
#Source0:        http://pypi.python.org/packages/source/m/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
Source0:        %{pypi_name}-%{version}.dev0.tar.gz
Source1:        mailman3.cfg
Source2:        mailman3-tmpfiles.conf
Source3:        mailman3.service
Source4:        mailman3.logrotate

# doctest hardcodes the exec path
Patch0:         mailman3-hooks-uselayout.patch
# Upstreamed but not released
#Patch10:        mailman3-e57787d.patch
# <https://gitlab.com/mailman/mailman/merge_requests/64>
Patch10:        %{name}-administrivia-headers.patch
Patch11:        %{name}-dirty-patches.patch
# <https://gitlab.com/mailman/mailman/merge_requests/57>
Patch12:        %{name}-fix-email-senders.patch
# <https://gitlab.com/mailman/mailman/merge_requests/61>
Patch13:        %{name}-fix-incoming-invalid-addresses.patch
# <https://gitlab.com/mailman/mailman/merge_requests/87>
Patch14:        %{name}-hide-system-disabled-archivers.patch
# <https://gitlab.com/mailman/mailman/merge_requests/37>
Patch15:        %{name}-listinfo-url.patch
# <https://gitlab.com/mailman/mailman/merge_requests/100>
Patch16:        %{name}-members-moderation-action.patch
Patch17:        %{name}-protect-deleted-queue-files.patch
# <https://gitlab.com/mailman/mailman/merge_requests/70>
Patch18:        %{name}-subject-prefix.patch
# <https://gitlab.com/mailman/mailman/merge_requests/32>
Patch19:        %{name}-user-merge.patch

BuildArch:      noarch

BuildRequires:  python3-pkgversion-macros
BuildRequires:  python%{python3_pkgversion}-devel >= 3.4
BuildRequires:  python%{python3_pkgversion}-setuptools

Requires:       python%{python3_pkgversion} >= 3.4
Requires:       python%{python3_pkgversion}-setuptools
Requires:       python%{python3_pkgversion}-alembic
Requires:       python%{python3_pkgversion}-falcon >= 0.3.0
Requires:       python%{python3_pkgversion}-flufl.bounce
Requires:       python%{python3_pkgversion}-flufl.i18n
Requires:       python%{python3_pkgversion}-flufl.lock
Requires:       python%{python3_pkgversion}-httplib2
Requires:       python%{python3_pkgversion}-lazr.config
Requires:       python%{python3_pkgversion}-lazr.smtptest
Requires:       python%{python3_pkgversion}-mock
Requires:       python%{python3_pkgversion}-nose2
# Versionned dep on python-passlib, or else it fails with AttributeError in
# mailman/utilities/passwords.py", line 43: 'CryptContext' has no attribute 'from_string'
Requires:       python%{python3_pkgversion}-passlib >= 1.6.0
# Uses the Query.one_or_none() method introduced in SQLAlchemy 1.0.9
Requires:       python%{python3_pkgversion}-sqlalchemy >= 1.0.9
Requires:       python%{python3_pkgversion}-zope-component
Requires:       python%{python3_pkgversion}-zope-configuration
Requires:       python%{python3_pkgversion}-zope-event
Requires:       python%{python3_pkgversion}-zope-interface

# SELinux
BuildRequires:  checkpolicy, selinux-policy-devel, /usr/share/selinux/devel/policyhelp
BuildRequires:  hardlink

# To run the test suite:
BuildRequires:  python-tox >= 1.7.0
BuildRequires:  python%{python3_pkgversion}-alembic
BuildRequires:  python%{python3_pkgversion}-falcon >= 0.3.0
BuildRequires:  python%{python3_pkgversion}-flufl.bounce
BuildRequires:  python%{python3_pkgversion}-flufl.i18n
BuildRequires:  python%{python3_pkgversion}-flufl.lock
BuildRequires:  python%{python3_pkgversion}-httplib2
BuildRequires:  python%{python3_pkgversion}-lazr.config
BuildRequires:  python%{python3_pkgversion}-lazr.smtptest
BuildRequires:  python%{python3_pkgversion}-mock
BuildRequires:  python%{python3_pkgversion}-nose2
BuildRequires:  python%{python3_pkgversion}-passlib >= 1.6.0
# Uses the Query.one_or_none() method introduced in SQLAlchemy 1.0.9
BuildRequires:  python%{python3_pkgversion}-sqlalchemy >= 1.0.9
BuildRequires:  python%{python3_pkgversion}-zope-component
BuildRequires:  python%{python3_pkgversion}-zope-configuration
BuildRequires:  python%{python3_pkgversion}-zope-event
BuildRequires:  python%{python3_pkgversion}-zope-interface
BuildRequires:  python%{python3_pkgversion}-psycopg2

# Scriptlets
Requires(pre):    shadow-utils
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
BuildRequires:    systemd


%description
This is GNU Mailman, a mailing list management system distributed under the
terms of the GNU General Public License (GPL) version 3 or later.  The name of
this software is spelled 'Mailman' with a leading capital 'M' but with a lower
case second `m'.  Any other spelling is incorrect.


%package selinux
%global selinux_variants mls targeted
Summary:        SELinux policy module for mailman3
Requires:       %{name} = %{version}-%{release}
%{!?_selinux_policy_version: %global _selinux_policy_version %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp 2>/dev/null)}
%if "%{_selinux_policy_version}" != ""
Requires:      selinux-policy >= %{_selinux_policy_version}
%endif

Requires(post):   /usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles, %{name}
Requires(postun): /usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles, %{name}

%description selinux
This is the SELinux module for mailman3, install it if you are using SELinux.



%prep
%setup -q -n %{pypi_name}-%{version}.dev0
%patch0 -p0 -b .hooks-uselayout
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1

# Remove bundled egg-info
rm -rf src/%{pypi_name}.egg-info

# SELinux
mkdir SELinux
echo '%{_localstatedir}/lib/%{name}/data(/.*)? gen_context(system_u:object_r:etc_mail_t,s0)' \
    > SELinux/%{name}.fc
# remember to bump the following version if the policy is updated
cat > SELinux/%{name}.te << EOF
policy_module(%{name}, 1.4)
EOF


%build
%{__python3} setup.py build

cd SELinux
for selinuxvariant in %{selinux_variants}; do
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
  mv %{name}.pp %{name}.pp.${selinuxvariant}
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done
cd -


%install
rm -rf %{buildroot}
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}

# move scripts away from _bindir to avoid conflicts and create a wrapper script
mkdir -p %{buildroot}%{_libexecdir}/%{name}
mv %{buildroot}%{_bindir}/* %{buildroot}%{_libexecdir}/%{name}/
cat > %{buildroot}%{_bindir}/%{name} << EOF
#!/bin/sh
if [ "\$(whoami)" != "mailman" ]; then
    echo "This command must be run under the mailman user."
    exit 1
fi
%{_libexecdir}/%{name}/mailman \$@
EOF
chmod +x %{buildroot}%{_bindir}/%{name}

# service files
install -D -m 0640 %{SOURCE1} %{buildroot}%{_sysconfdir}/mailman.cfg
install -D -m 0644 %{SOURCE2} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf
install -D -m 0644 %{SOURCE3} %{buildroot}%{_prefix}/lib/systemd/system/%{name}.service
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
sed -e 's,@LOGDIR@,%{_localstatedir}/log/%{name},g;s,@BINDIR@,%{_bindir},g' \
    %{SOURCE4} > %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

mkdir -p %{buildroot}%{_localstatedir}/{lib,spool,log}/%{name}
mkdir -p %{buildroot}/run/%{name} %{buildroot}/run/lock/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/%{name}.d
# Mailman will auto-create the following dir, but not with the correct group
# owner (MTAs such as Postfix must read and write to it). Set it here in RPM's
# file listing.
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/data

# SELinux
for selinuxvariant in %{selinux_variants}; do
  install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 SELinux/%{name}.pp.${selinuxvariant} \
    %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{name}.pp
done
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux


%check
tox --sitepackages -e py%{python3_pkgversion}


%pre
getent group %{mmgroup} >/dev/null || \
    groupadd -g %{mmgroupid} %{mmgroup} >/dev/null
getent passwd %{mmuser} >/dev/null || \
    useradd -r -u %{mmuserid} -g %{mmgroupid} -d %{_localstatedir}/lib/%{name} -s /sbin/nologin \
        -c "Mailman, the mailing-list manager" %{mmuser} >/dev/null
exit 0

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%post selinux
for selinuxvariant in %{selinux_variants}; do
  /usr/sbin/semodule -s ${selinuxvariant} -i \
    %{_datadir}/selinux/${selinuxvariant}/%{name}.pp &> /dev/null || :
done
/sbin/fixfiles -R %{name} restore || :
/sbin/restorecon -R %{_localstatedir}/lib/%{name} || :

%postun selinux
if [ $1 -eq 0 ] ; then
  for selinuxvariant in %{selinux_variants}; do
    /usr/sbin/semodule -s ${selinuxvariant} -r %{name} &> /dev/null || :
  done
  /sbin/fixfiles -R %{name} restore || :
  [ -d %{_localstatedir}/lib/%{name} ]  && \
    /sbin/restorecon -R %{_localstatedir}/lib/%{name} &> /dev/null || :
fi


%files
%doc README.rst
%{_bindir}/%{name}
%{_libexecdir}/%{name}
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-*-py?.?.egg-info
%{_prefix}/lib/systemd/system/%{name}.service
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%config(noreplace) %attr(640,mailman,mailman) %{_sysconfdir}/mailman.cfg
%dir %{_sysconfdir}/%{name}.d
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(755,mailman,mailman) %{_localstatedir}/lib/%{name}
%dir %attr(2775,mailman,mail)   %{_localstatedir}/lib/%{name}/data
%dir %attr(755,mailman,mailman) %{_localstatedir}/spool/%{name}
%dir %attr(755,mailman,mailman) %{_localstatedir}/log/%{name}
%dir %attr(755,mailman,mailman) /run/%{name}
%dir %attr(755,mailman,mailman) /run/lock/%{name}

%files selinux
%defattr(-,root,root,0755)
%doc SELinux/*
%{_datadir}/selinux/*/%{name}.pp


%changelog
* Wed Apr 29 2015 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-1
- version 3.0.0 final

* Fri Jul 18 2014 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-0.18.bzr7251
- add Patch11 (missing PostgreSQL upgrade file)

* Mon Nov 25 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-0.11.bzr7226
- add SELinux policy module, according to:
  http://fedoraproject.org/wiki/SELinux_Policy_Modules_Packaging_Draft

* Sun Oct 27 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-0.10.bzr7226
- update to BZR snapshot (rev7226)

* Thu Aug 29 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-0.6.bzr7218
- update to BZR snapshot (rev7218)

* Wed Aug 28 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0-0.6.bzr7217
- update to BZR snapshot (rev7217)
- drop patch 0
- rename to mailman3 and make it parallel-installable with Mailman 2

* Wed Jul 24 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3:3.0.0-0.6
- update to BZR snapshot (rev7215)
- drop patch 1

* Thu Mar 07 2013 Aurelien Bompard <abompard@fedoraproject.org> - 3:3.0.0-0.2.b3
- update to beta3
- add a systemd service and a default config file

* Wed Nov 28 2012 Aurelien Bompard <abompard@fedoraproject.org> - 3.0.0b2-1
- Initial package.
